<html>
  <head>
    <meta charset="utf-8" />
    <title>Tests pour le Projet LIFAP5</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <link rel="stylesheet" href="https://unpkg.com/mocha/mocha.css" />
  </head>
  <body>
    <h1>Tests pour le Projet LIFAP5</h1>
    <div id="mocha"></div>

    <script src="https://unpkg.com/chai/chai.js"></script>
    <script src="https://unpkg.com/mocha/mocha.js"></script>

    <!-- https://mochajs.org/#running-mocha-in-the-browser -->
    <script class="mocha-init">
      console.debug('Initialisation mocha');
      mocha.setup('tdd');
      mocha.checkLeaks();
      //mocha.globals(['jQuery']);
    </script>

    <script src="test.js"></script>
    <script>
		const apiKey = "dda60d7a-820e-4b74-a882-92c74c3d1303";
		const serverUrl = "https://lifap5.univ-lyon1.fr";
		
   /**
	 * Permet de générer un nombre aléatoire entre le minimum et le maximum
	 *
	 * @param {min, max} min et max étant respectivement le minimum et le maximum
	 * @returns un nombre aléatoire compris entre min et max inclus
	 */
	function genererNbAleatoire(min,max)
	{
		return Math.floor(Math.random()*(max-min+1))+min;
	}

	/**
	 * Permet de générer un nombre aléatoire entre le minimum et le maximum, avec un nombre interdit dans l'intervalle
	 *
	 * @param {min, max, numCitation1} min et max étant respectivement le minimum et le maximum. numCitation1 correspond au numéro de la 1ère citation aléatoire
	 * @returns un nombre aléatoire compris entre min et max inclus, en excluant la valeur de numCitation1
	 */
	function genererNbAleatoire2(min,max, numCitation1)
	{
		const nbAleatoire = Math.floor(Math.random()*(max-min+1))+min;
		return (nbAleatoire === numCitation1) ? genererNbAleatoire2(min, max, numCitation1) : nbAleatoire;
	}

	/**
	 * Créer un tableau contenant 2 citations aléatoire différentes et le retourne
	 *
	 * @param {Etat} etatCourant l'état courant
	 * @returns un tableau contenant 2 citations aléatoires différentes
	 */
	function choixCitationAleatoire(etatCourant)
	{
		const nbCitations = etatCourant.citations.length;
		const nbAleatoire = genererNbAleatoire(0,nbCitations);
		const nbAleatoire2 = genererNbAleatoire2(0,nbCitations, nbAleatoire);
		const tab2Citations = [etatCourant.citations[nbAleatoire], etatCourant.citations[nbAleatoire2]];
		return(tab2Citations);
	}
	
	function fetchWhoami() {
	  return fetch(serverUrl + "/whoami", { headers: { "x-api-key": apiKey } })
		.then((response) => response.json())
		.then((jsonData) => {
		  if (jsonData.status && Number(jsonData.status) != 200) {
			return { err: jsonData.message };
		  }
		  return jsonData;
		})
		.catch((erreur) => ({ err: erreur }));
	}
    </script>

    <script class="mocha-exec">
      console.debug('Exécution mocha');
      mocha.run();
    </script>
  </body>
</html>
